<template>
  <v-row>
    <v-col>
      <div class="mb-8 w-100 d-flex justify-space-between align-center">
        <v-text-field v-model="query" placeholder="Recherche" clearable data-cy="UserListSearchInput" density="compact"
          rounded variant="outlined" color="primary" hide-details max-width="400" bgColor="white">
          <template #append-inner v-if="!query">
            <v-icon>search</v-icon>
          </template>
        </v-text-field>

        <v-btn variant="outlined" rounded class="text-uppercase" @click="createUser()" data-cy="AddUserBtn">
          <v-icon left>add</v-icon>
          Ajouter un utilisateur
        </v-btn>
      </div>

      <v-data-table :headers="headers" :items="usersFiltered" disable-pagination hide-default-footer
        :row-props="rowDisabledClass" density="compact" loading-text="Chargement des utilisateurs ..."
        no-results-text="Aucun utilisateur ne correspond à cette recherche"
        no-data-text="Aucun utilisateur ne correspond à cette recherche" class="airvam-table">

        <template #item.rank="{ item }: { item: User }">
          {{ item.rank ? item.rank.name : '' }}
        </template>

        <template #item.unit="{ item }: { item: User }">
          {{ item.unit ? item.unit.name : '' }}
        </template>

        <template #item.role="{ item }: { item: User }">
          {{ userRole[item.role] }}
        </template>

        <template #item.actions="{ item }: { item: User }">
          <div class="d-flex">
            <v-btn icon flat size="x-small" data-cy="EditUserBtn" @click="askEditUser(item)" :disabled="!canEditUser(item)"
              class="mr-1 action">
              <v-icon>edit</v-icon>
            </v-btn>

            <v-btn icon flat size="x-small" class="action" data-cy="DeleteUserBtn" :disabled="!canEditUser(item)"
              @click="askActivateDeactivateUser(item)">
              <v-icon v-if="!item.disabled">lock</v-icon>
              <v-icon v-if="item.disabled">lock_open</v-icon>
            </v-btn>

            <v-btn icon flat v-if="item.disabled" size="x-small" class="ml-1 action" data-cy="DeletePermanentUserBtn"
              :disabled="!canEditUser(item)" @click="askDeleteUser(item)">
              <v-icon>delete</v-icon>
            </v-btn>
          </div>
        </template>
      </v-data-table>


      <LazyAdminUsersUserDialog v-if="editedUser" v-model="userDialog" :user="editedUser" :isNewUser="isNewUser"
        @confirm="createEditUser" @close="close" />

      <LazyConfirmDialog v-if="userDialogActivateDeactivate" v-model="userDialogActivateDeactivate"
        :dialogText="userDialogActivateDeactivateText" :dialogTitle="userDialogActivateDeactivateTitle"
        @confirm="activateDeactivateUser" @close="close" />
    </v-col>
  </v-row>
</template>

<script setup lang="ts">
import { debounce } from "../../mixins/utilsMixin";
import { User } from "@/dto/user.dto";
import { UserRole } from "@/dto/userRole.enum";

const { $api, $toast } = useNuxtApp();
const store = useStore();
const { users } = storeToRefs(useStore());

const userDialog = ref(false);
const userDialogActivateDeactivate = ref(false);
const userDialogActivateDeactivateTitle = ref('');
const userDialogActivateDeactivateText = ref('');
const editedUser: Ref<User | null> = ref(null);
const usersFiltered: Ref<User[]> = ref([]);
const isNewUser = ref(false);
const toDelete = ref(false);
const query = ref('');
const headers: Ref<any[]> = ref([
  { title: 'Email', value: 'email', },
  { title: 'Prénom', value: 'firstName' },
  { title: 'Nom', value: 'lastName' },
  { title: 'Grade', value: 'rank' },
  { title: 'Unité', value: 'unit' },
  { title: 'Rôle', value: 'role' },
  { title: '', value: 'actions', sortable: false },
]);

const userRole = UserRole

const createUser = () => {
  const user = new User();
  isNewUser.value = true;
  askEditUser(user);
}

const askEditUser = (item: User) => {
  if (!canEditUser(item)) {
    return;
  }
  editedUser.value = Object.assign({}, item);
  userDialog.value = true;
}

const askActivateDeactivateUser = (item: User) => {
  if (!canEditUser(item)) {
    return;
  }
  editedUser.value = Object.assign({}, item);
  userDialogActivateDeactivateTitle.value = item.disabled ? `Activation d'un utilisateur` : `Désactivation d'un utilisateur`
  userDialogActivateDeactivateText.value = item.disabled ? `Êtes-vous sûr de vouloir ré-activer l'utilisateur "${editedUser.value.email}" ?`
    : `Êtes-vous sûr de vouloir désactiver l'utilisateur "${editedUser.value.email}" ?`;
  userDialogActivateDeactivate.value = true;
}

const askDeleteUser = (item: User) => {
  if (!canEditUser(item)) {
    return;
  }
  editedUser.value = Object.assign({}, item);
  userDialogActivateDeactivateTitle.value = `Suppression d'un utilisateur`
  userDialogActivateDeactivateText.value = `Êtes-vous sûr de vouloir supprimer l'utilisateur "${editedUser.value.email}" ? Cette action est irréversible !`;
  userDialogActivateDeactivate.value = true;
  toDelete.value = true;
}

const close = () => {
  userDialogActivateDeactivate.value = false;
  userDialog.value = false;
  editedUser.value = null;
  isNewUser.value = false;
  toDelete.value = false;
}

const createEditUser = async () => {
  try {
    const userReturned = !isNewUser.value ? await $api.user.update(editedUser.value, editedUser.value?.email)
      : await $api.user.create(editedUser.value);
    await store.editList({ listName: 'users', item: userReturned, id: 'email' });
    $toast.success(!isNewUser.value ? "Utilisateur modifié" : "Utilisateur crée");
  } catch (e) {
    // console.log(e.response?.data?.message);
    $toast.error(!isNewUser.value ? "Erreur lors de l'édition d'un utilisateur" : "Erreur lors de la création d'un utilisateur");
  }
  filter();
  close();
}

const activateDeactivateUser = async () => {
  if (toDelete.value) {
    return deleteUser();
  }
  try {
    const userReturned = editedUser.value?.disabled ? await $api.user.activate(editedUser.value?.email)
      : await $api.user.delete(editedUser.value?.email);
    await store.editList({ listName: 'users', item: userReturned, id: 'email' });
    $toast.success(userReturned.disabled ? "Utilisateur désactivé" : "Utilisateur ré-activé");
  } catch (e) {
    // console.log(e.response?.data?.message);
    $toast.error(editedUser.value?.disabled ? "Erreur lors de la ré-activation d'un utilisateur" : "Erreur lors de la désactivation d'un utilisateur");
  }
  filter();
  close();
}

const deleteUser = async () => {
  try {
    await $api.user.deletePermanent(editedUser.value?.email);
    store.deleteFromList({ listName: 'users', item: editedUser.value, id: 'email' });
    $toast.success("Utilisateur supprimée");
  } catch (e) {
    // console.log(e.response?.data?.message);
    $toast.error("Erreur lors de la suppression d'un utilisateur");
  }
  filter();
  close();
}

const rowDisabledClass = ({ item }: { item: User }) => {
  return item.disabled ? { class: "disabled" } : undefined;
}

const canEditUser = (user: User): boolean => {
  return !(store.loggedInUser?.role === 'admin' && user.role === 'god');
}

const filter = () => {
  usersFiltered.value = [...users.value].filter(u => {
    if (!query.value || query.value === '') {
      return true;
    }
    return u.email?.toUpperCase().includes(query.value.toUpperCase())
      || u.firstName?.toUpperCase().includes(query.value.toUpperCase())
      || u.lastName?.toUpperCase().includes(query.value.toUpperCase())
  });
}

filter();

watch(query, debounce(function () {
  filter();
}, 300));

</script>
